"""init

Revision ID: fda694e67f67
Revises: 
Create Date: 2023-07-05 11:39:05.497527

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = 'fda694e67f67'
down_revision = None
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('user',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('username', sa.String(length=50), nullable=False),
    sa.Column('password', sa.String(length=120), nullable=False),
    sa.Column('stripe_customer', sa.String(length=256), nullable=True),
    sa.Column('admin', sa.Boolean(), nullable=False),
    sa.Column('due_at', sa.Date(), nullable=True),
    sa.Column('created_at', sa.Date(), server_default=sa.text('CURRENT_DATE'), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('username')
    )
    op.create_table('client',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('address', sa.String(length=500), nullable=False),
    sa.Column('email', sa.String(length=70), nullable=False),
    sa.Column('label', sa.String(length=40), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_client_user_id'), 'client', ['user_id'], unique=False)
    op.create_table('payment',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.Column('date', sa.Date(), nullable=False),
    sa.Column('valid_for_service_thru', sa.Date(), nullable=False),
    sa.Column('amount', sa.Integer(), nullable=False),
    sa.Column('currency', sa.String(length=10), nullable=True),
    sa.Column('payload', sa.JSON(), nullable=True),
    sa.Column('card_brand', sa.String(length=20), nullable=True),
    sa.Column('card_last4', sa.String(length=4), nullable=True),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_payment_user_id'), 'payment', ['user_id'], unique=False)
    op.create_table('product',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('label', sa.String(length=120), nullable=False),
    sa.Column('price', sa.Integer(), nullable=False),
    sa.Column('tax_rate', sa.Integer(), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_product_user_id'), 'product', ['user_id'], unique=False)
    op.create_table('user_password_reset_token',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.Column('token', sa.String(length=128), nullable=False),
    sa.Column('expire_at', sa.DateTime(), server_default=sa.text('current_timestamp'), nullable=False),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('token')
    )
    op.create_index(op.f('ix_user_password_reset_token_user_id'), 'user_password_reset_token', ['user_id'], unique=False)
    op.create_table('user_pref',
    sa.Column('bill_mentions', sa.String(length=500), nullable=True),
    sa.Column('currency', sa.String(length=10), nullable=True),
    sa.Column('email', sa.String(length=254), nullable=True),
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('locale', sa.String(length=10), nullable=False),
    sa.Column('quote_mentions', sa.String(length=500), nullable=True),
    sa.Column('smtp_host', sa.String(length=30), nullable=True),
    sa.Column('smtp_password', sa.String(length=30), nullable=True),
    sa.Column('smtp_port', sa.Integer(), nullable=True),
    sa.Column('smtp_security', sa.String(length=10), nullable=True),
    sa.Column('smtp_username', sa.String(length=30), nullable=True),
    sa.Column('smtp_reply_to', sa.String(length=254), nullable=True),
    sa.Column('smtp_cc', sa.String(length=508), nullable=True),
    sa.Column('source', sa.String(length=500), nullable=True),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('email')
    )
    op.create_index(op.f('ix_user_pref_user_id'), 'user_pref', ['user_id'], unique=False)
    op.create_table('bill',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('client_id', sa.Integer(), nullable=True),
    sa.Column('comment', sa.String(length=500), nullable=True),
    sa.Column('date', sa.Date(), nullable=False),
    sa.Column('bill_number', sa.Integer(), nullable=True),
    sa.Column('quote_number', sa.Integer(), nullable=True),
    sa.Column('recipient', sa.String(length=500), nullable=True),
    sa.Column('source', sa.String(length=500), nullable=True),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.Column('bill_mentions', sa.String(length=500), nullable=True),
    sa.Column('quote_mentions', sa.String(length=500), nullable=True),
    sa.Column('paid', sa.Boolean(), server_default='FALSE', nullable=False),
    sa.ForeignKeyConstraint(['client_id'], ['client.id'], ),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('user_id', 'bill_number'),
    sa.UniqueConstraint('user_id', 'quote_number')
    )
    op.create_index(op.f('ix_bill_bill_number'), 'bill', ['bill_number'], unique=False)
    op.create_index(op.f('ix_bill_client_id'), 'bill', ['client_id'], unique=False)
    op.create_index(op.f('ix_bill_quote_number'), 'bill', ['quote_number'], unique=False)
    op.create_index(op.f('ix_bill_user_id'), 'bill', ['user_id'], unique=False)
    op.create_table('bill_row',
    sa.Column('bill_id', sa.Integer(), nullable=False),
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('label', sa.String(length=120), nullable=False),
    sa.Column('price', sa.Integer(), nullable=False),
    sa.Column('quantity', sa.Integer(), nullable=False),
    sa.Column('tax_rate', sa.Integer(), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['bill_id'], ['bill.id'], ),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_bill_row_bill_id'), 'bill_row', ['bill_id'], unique=False)
    op.create_index(op.f('ix_bill_row_user_id'), 'bill_row', ['user_id'], unique=False)
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index(op.f('ix_bill_row_user_id'), table_name='bill_row')
    op.drop_index(op.f('ix_bill_row_bill_id'), table_name='bill_row')
    op.drop_table('bill_row')
    op.drop_index(op.f('ix_bill_user_id'), table_name='bill')
    op.drop_index(op.f('ix_bill_quote_number'), table_name='bill')
    op.drop_index(op.f('ix_bill_client_id'), table_name='bill')
    op.drop_index(op.f('ix_bill_bill_number'), table_name='bill')
    op.drop_table('bill')
    op.drop_index(op.f('ix_user_pref_user_id'), table_name='user_pref')
    op.drop_table('user_pref')
    op.drop_index(op.f('ix_user_password_reset_token_user_id'), table_name='user_password_reset_token')
    op.drop_table('user_password_reset_token')
    op.drop_index(op.f('ix_product_user_id'), table_name='product')
    op.drop_table('product')
    op.drop_index(op.f('ix_payment_user_id'), table_name='payment')
    op.drop_table('payment')
    op.drop_index(op.f('ix_client_user_id'), table_name='client')
    op.drop_table('client')
    op.drop_table('user')
    # ### end Alembic commands ###
